#! /bin/sh
#
### BEGIN INIT INFO
# Provides:          havp
# Required-Start:    $syslog $local_fs $network
# X-UnitedLinux-Should-Start: 
# Required-Stop:     $local_fs $network
# X-UnitedLinux-Should-Stop: 
# Default-Start:     3 5
# Default-Stop:      0 1 2 6
# Short-Description: HAVP daemon providing HTTP proxy with virus scanning
# Description:       Start HAVP to provide HTTP virus scanning
#       which uses the ClamAV engine
### END INIT INFO
# 


# Check for missing binaries (stale symlinks should not happen)
HAVP_BIN=/usr/sbin/havp
test -x $HAVP_BIN || { echo "$HAVP_BIN not installed"; exit 5; }

HAVP_CONF="/etc/havp/havp.config"
test -f $HAVP_CONF || { echo "$HAVP_CONF not found"; exit 5; }

PIDFILE="`grep -v '#' $HAVP_CONF | grep -w PIDFILE | awk '{print $2}'`"
LOGDIRTMP="`grep -v '#' $HAVP_CONF | grep -w ERRORLOG | awk '{print $2}'`"
LOGDIR="`dirname $LOGDIRTMP`"

# Check for existence of needed config file and read it
#HAVP_CONFIG=/etc/sysconfig/havp
#test -r $HAVP_CONFIG || { echo "$HAVP_CONFIG not existing"; exit 6; }
#. $HAVP_CONFIG

. /etc/rc.status

# Reset status of this service
rc_reset


case "$1" in
    start)
	echo -n "Starting HAVP "
	## Start daemon with startproc(8). If this fails
	## the return value is set appropriately by startproc.
	startproc -l $LOGDIR/rchavp -p $PIDFILE $HAVP_BIN -c $HAVP_CONF >/dev/null

	# Remember status and be verbose
	rc_status -v
	;;
    stop)
	echo -n "Shutting down HAVP "
	## Stop daemon with killproc(8) and if this fails
	## killproc sets the return value according to LSB.

	killproc -p $PIDFILE -TERM $HAVP_BIN

	# Remember status and be verbose
	rc_status -v
	;;
    try-restart|condrestart)
	## Do a restart only if the service was active before.
	## Note: try-restart is now part of LSB (as of 1.9).
	## RH has a similar command named condrestart.
	if test "$1" = "condrestart"; then
		echo "${attn} Use try-restart ${done}(LSB)${attn} rather than condrestart ${warn}(RH)${norm}"
	fi
	$0 status
	if test $? = 0; then
		$0 restart
	else
		rc_reset	# Not running is not a failure.
	fi
	# Remember status and be quiet
	rc_status
	;;
    restart)
	## Stop the service and regardless of whether it was
	## running or not, start it again.
	$0 stop
	$0 start

	# Remember status and be quiet
	rc_status
	;;
    force-reload)
	## Signal the daemon to reload its config. Most daemons
	## do this on signal 1 (SIGHUP).
	## If it does not support it, restart.

	echo -n "Reload service HAVP "
	## if it supports it:
	killproc -HUP $HAVP_BIN
	#touch /var/run/FOO.pid
	rc_status -v

	## Otherwise:
	#$0 try-restart
	#rc_status
	;;
    reload)
	## Like force-reload, but if daemon does not support
	## signaling, do nothing (!)

	# If it supports signaling:
	echo -n "Reload service HAVP "
	killproc -HUP $HAVP_BIN
	#touch /var/run/FOO.pid
	rc_status -v
	
	## Otherwise if it does not support reload:
	#rc_failed 3
	#rc_status -v
	;;
    status)
	echo -n "Checking for service HAVP "
	## Check status with checkproc(8), if process is running
	## checkproc will return with exit status 0.

	# Return value is slightly different for the status command:
	# 0 - service up and running
	# 1 - service dead, but /var/run/  pid  file exists
	# 2 - service dead, but /var/lock/ lock file exists
	# 3 - service not running (unused)
	# 4 - service status unknown :-(
	# 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)
	
	# NOTE: checkproc returns LSB compliant status values.
	checkproc $HAVP_BIN
	# NOTE: rc_status knows that we called this init script with
	# "status" option and adapts its messages accordingly.
	rc_status -v
	;;
    probe)
	## Optional: Probe for the necessity of a reload, print out the
	## argument to this init script which is required for a reload.
	## Note: probe is not (yet) part of LSB (as of 1.9)

	#test /etc/FOO/FOO.conf -nt /var/run/FOO.pid && echo reload
	;;
    *)
	echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload|probe}"
	exit 1
	;;
esac
rc_exit
